/// Response example:
/// [
/// {
///     "type": "A",
///     "question_number": "1",
///     "issued_at": "2018-12-11 23:09:01",
///     "status": "D",
///     "appeal": "Мы считаем, что ответ \"Руководитель палаты мер и весов\" целиком и полностью свидетельствует о проникновении командой в логику вопроса, а явного требования назвать фамилию человека в вопросе дано не было. Из комментария к вопросу, а также из комментария к одному из незасчитанных спорных ответов, прямо следует, что функцией новгородского владыки также являлось хранение этанолов мер и весов. Функцию хранения этанолов мер и весов в России в XIX и XX веке выполнял Управляющий Главной палатой мер и весов.\r\n\r\nВ соответствии с п. 2.1.1 Кодекса спортивного \"Что?Где?Когда?\", ответ команды считается правильным, если он <...> соответствует форме вопроса и требованиям к формулировке ответа и при этом может быть интерпретирован как развернутый ответ, т.е. включает авторский или эквивалентный ему ответ, а также дополнительную информацию, которая не может быть принята за другой ответ, не противоречит содержанию вопроса и не содержит грубых фактических ошибок.\r\n\r\nПросим апелляционное жюри зачесть наш ответ как правильный. Спасибо.",
///     "comment": "Отклонить 2:1 (АВ, РХ — за отклонение; ИИ — за принятие).\r\rСогласно пункту 2.1.4.2 Кодекса, описательный ответ (в котором вместо наименования объекта или субъекта даются его свойства), как правило, засчитываться не должен.",
///     "resolved_at": "2018-12-19 18:36:59",
///     "answer": "Руководитель палаты мер и весов"
/// },
/// {
///     "type": "A",
///     "question_number": "5",
///     "issued_at": "2018-12-12 01:39:54",
///     "status": "D",
///     "appeal": "Судя по выдаче поисковиковых машин, \"Нибиру\" является распространённым обозначением для гипотетической планеты Солнечной Системы за Нептуном. В тексте нет отсечек для авторского ответа на первый подвопрос, за исключением каламбура с римской цифрой X. Проникновение в логику у команды явно присутствует.",
///     "comment": "Отклонить 3:0.\r\rНаименование «Нибиру» в данном контексте нельзя считать эквивалентом «Планеты X». В общем случае Нибиру означает конкретную планету из вселенной Захарии Ситчина, реально не наблюдаемую с Земли, а описанную только теоретически. С другой стороны, под планетой X в общем случае подразумевают некую неизвестную планету дальше Нептуна. Свойства и факты, приписываемые Нибиру (местообитание человекоподобной расы аннунаков, столкновение с планетой Тиамат и формирование в результате этого планеты Земля), не совпадают со свойствами и фактами, приписываемыми планете X.",
///     "resolved_at": "2018-12-19 18:37:30",
///     "answer": "1) Нибиру, 2) Солнечная система"
/// },
/// {
///     "type": "R",
///     "question_number": "10",
///     "issued_at": "2018-12-14 21:36:31",
///     "status": "D",
///     "appeal": "В авторских источниках мне не удалось обнаружить того утверждения, что электрический свет как-то влиял на восприятие созданных скульптором масок для раненых. Т.к. факт не подтверждается источником, вопрос будет уместо снять.",
///     "comment": "Отклонить 3:0.\r\rПриводим альтернативные источники, где содержится нужное утверждение, и передаём извинения от редактора за то, что их нет в самом пакете:\r1. https://goo.gl/VE6625\r2. https://goo.gl/mdRhu4",
///     "resolved_at": "2018-12-19 18:38:14",
///     "answer": null
/// },
/// {
///     "type": "A",
///     "question_number": "13",
///     "issued_at": "2018-12-13 00:54:24",
///     "status": "D",
///     "appeal": "Пластиковый бонг является пластиковым это уже хорошо. При использование (если верить интернету) бонга он нагреваетеся, а значит с пластиком происходит процесс аналогичный процессу в пластиковых стаканчиках. А зачастую бонг курят для того, чтобы взбодриться, поднять настроение, очухаться - прям как кофе. То есть и под смысловую часть наш ответ подходит не хуже. А если учесть, что бонг можно назвать посудой, то ответ команды является частным случаем общего ответа, при этом подпадающим под все факты вопроса.",
///     "comment": "Отклонить 3:0.\r\rВо-первых, ответ не соответствует авторскому источнику, а альтернативных, в пользу своего ответа, с упоминанием взаимосвязи со стиролом, апеллянты не приводят. Во-вторых, руководствуясь общими соображениями и личным опытом, жюри возражает, что в подавляющем числе случаев бонги используют для употребления веществ с седативным эффектом, а не бодрящих. Этот тезис подтверждается, например, Википедией, которая определяет бонг как «устройство для курения конопли и табака» и приводит некоторые факты о том, что в отдельных местностях бонги только с этими веществами и ассоциируются.\rТаким образом, использование пластиковых бонгов можно только рекомендовать. Только просим вас помнить о статье 228 Кодекса (не МАК).",
///     "resolved_at": "2018-12-19 18:38:49",
///     "answer": "пластиковые бонги"
/// },
/// {
///     "type": "R",
///     "question_number": "18",
///     "issued_at": "2018-12-13 17:08:30",
///     "status": "D",
///     "appeal": "Ответ на вопрос \"кому?\" должен, извините за тривиальность, отвечать на вопрос \"кто?\". И Франция, и сборная Франции отвечают на вопрос \"что?\". Это не придирка. Мы обратили внимание на форму вопроса и рассматривали отдельных футболистов, но не сборную и не страну. Просим снять вопрос.",
///     "comment": "Отклонить 3:0.\r\rВ подобных случаях, когда речь идёт о группе людей, постановка вопроса «кто / кому?» является допустимой. Несколько реальных примеров конструкций, из которых такая постановка прямо следует (выделение большими буквами наше):\r \rhttp://kvn.ru/news/15301 — «Первая команда, КОМУ аплодировали зрители после выступления чуть дольше обычного…»\rhttps://ru.wikipedia.org/?curid=2339095 — «До сих пор повторить успех и составить достойную конкуренцию «Комбинации» среди девичьих групп больше НИКОМУ так и не удалось!»\rhttps://ru.wikipedia.org/?curid=386838 — «Группа «Многоточие» стали одними из немногих, КОМУ удалось создать «культовый» статус андеграунд-исполнителей…»\rhttps://tvzvezda.ru/sp/fifa-2018/teams/isl.html — «Кстати, Исландия — первая страна с населением до миллиона человек, КОМУ удалось выйти на ЧМ...»\rhttps://ru.wikipedia.org/?curid=1724182 — «Команда из Марракеша стала первым марокканским клубом, КОМУ удалось выиграть третий по значимости континентальный трофей - Кубок КАФ...»\r \rПри этом постановки вопроса «что / чему?» для подобных случаев жюри найти не удалось.\rКасаемо научного обоснования. Несмотря на то, что во многих источниках (например, https://goo.gl/BbDhbS, https://goo.gl/FwFUKY, https://goo.gl/iXzrxh) совокупности одушевлённых предметов определяются как грамматически неодушевлённые и, таким образом, отвечающие на вопрос «что / чему?», лингвистами констатируется множество проблемных зон и противоречий в области трактовки носителями языка категории одушевлённости. Так, в недавнем исследовании (https://goo.gl/uCpLhw) к одной из таких зон относят как раз «существительные, обозначающие нерасчленённую совокупность живых существ, и существительные во множественном числе, употребляемые в особых предложных конструкциях», куда относится и наш случай.\rПри рассмотрении апелляции на снятие вопроса конфликт источников (в данном случае это явный конфликт между практическим словоупотреблением и положениями языковых справочников) работает в пользу автора вопроса, то есть считается, что у утверждения в вопросе существует корректная трактовка.",
///     "resolved_at": "2018-12-19 18:39:16",
///     "answer": null
/// },
/// {
///     "type": "R",
///     "question_number": "18",
///     "issued_at": "2018-12-13 18:16:52",
///     "status": "D",
///     "appeal": "Вопросная фраза звучала как \"Кому последнему...\" то есть ни \"Кому последним\" намекая на множество людей, как на команду или \"Кому последней\", намекая хотя бы на женский род слова команда/сборная и слова Франция, а именно \"Кому последнему\".  Это существенная ошибка в тексте вопроса, которая повлияла на выбор ответа, потому что от футбола пришлось пойти в индивидуальные виды спорта, не требующие существенных затрат на инвентарь. Марафон, лыжи, шахматы, покер и т.д.\r\n\r\nк сведению ИЖ: Норвегия  - далеко не самая богатая страна, по различным оценкам она занимает 28-54 место в мире по разным оценкам: https://ru.wikipedia.org/wiki/%D0%A1%D0%BF%D0%B8%D1%81%D0%BE%D0%BA_%D1%81%D1%82%D1%80%D0%B0%D0%BD_%D0%BF%D0%BE_%D0%92%D0%92%D0%9F_(%D0%BD%D0%BE%D0%BC%D0%B8%D0%BD%D0%B0%D0%BB)\r\nhttps://ru.wikipedia.org/wiki/%D0%A1%D0%BF%D0%B8%D1%81%D0%BE%D0%BA_%D1%81%D1%82%D1%80%D0%B0%D0%BD_%D0%BF%D0%BE_%D0%92%D0%92%D0%9F_(%D0%9F%D0%9F%D0%A1)",
///     "comment": "Отклонить 3:0.\r \rСм. вердикт по апелляции 9924: http://rating.chgk.info/appeal/9924",
///     "resolved_at": "2018-12-19 18:39:36",
///     "answer": null
/// },
/// {
///     "type": "R",
///     "question_number": "22",
///     "issued_at": "2018-12-12 20:46:54",
///     "status": "D",
///     "appeal": "Уважаемое апелляционное жюри. \r\n\r\nПросим снять вопрос №22, содержащий преднамеренную лингвистическую ошибку. \r\n\r\nСогласно существующим стилистическим нормам русского языка, попасть НА ферму авиационные бомбы могут только в том случае, если были на неё привезены. В случае же попадания при бомбардировке обязательно должен быть использован оборот =попали В ферму=. Обильные примеры и первого, и второго вариантов можно найти запросом ПОПАДАНИЕ БОМБЫ В и ПОПАДАНИЕ БОМБЫ НА в любой поисковой системе. Хотелось бы подчеркнуть, что в составе апеллирующей команды есть профессиональные филологи и редакторы, для которых недопустимость использования тропа =попадание на ферму нескольких бомб= в контексте вопроса очевидна и не позволила рассмотреть пришедшую на первой секунде версию всерьёз.\r\n\r\nЗаранее спасибо.",
///     "comment": "Принять 2:1.\r\rЖюри считает, что такой троп действительно может помешать сдать авторский ответ, однако отмечает, что конструкция «авиабомба попала на ферму через крышу» возможна в ироничном смысле или образно, поэтому некорректность не так уж однозначна. Ср. с выражением, например, «поймать пулю», когда пуля попадает в человека.\rПо регламенту турнира, снятие вопроса происходит только в результате единогласного решения жюри.",
///     "resolved_at": "2018-12-19 18:40:05",
///     "answer": null
/// },
/// {
///     "type": "A",
///     "question_number": "23",
///     "issued_at": "2018-12-12 19:31:44",
///     "status": "D",
///     "appeal": "Просим зачесть ответ \"учитель латыни\", как удовлетворяющий всем реалиям вопроса и показывающий проникновение в логику вопроса, а именно, что латынь во времена жизни Польхема являлась международным языком науки, без знания которой он не мог продвинуться дальше в изучении механики и математики.\r\nТакже согласно одному из определений слова \"учитель\" - это лицо, обучающее, учащее чему-нибудь. Следовательно, викарий, у которого Кристофер Польхем брал уроки латыни, является в том числе и учителем латыни. Поэтому ответ \"учитель латыни\" в реалиях данного вопроса описывает только одного человека, который обучал Польхема.\r\n(https://dic.academic.ru/dic.nsf/ushakov/1073838)",
///     "comment": "Отклонить 2:1 (АВ, РХ — за отклонение; ИИ — за принятие).\r\rФормально указание в вопросе «местному» однозначно говорит о неком основном роде занятий человека, к которому обратился учёный. Пастор по факту не был профессиональным учителем латыни.\rНеформально команда недостаточно проникла в логику вопроса: поняв, что Польхем хотел изучить латынь, она не поняла, что нормальных способов это сделать в реалиях того времени у него не было, и он изыскал некий нестандартный, который также требовалось вычислить. Это обстоятельство большинству членов жюри видится существенным.",
///     "resolved_at": "2018-12-19 18:40:37",
///     "answer": "учитель латыни"
/// },
/// {
///     "type": "R",
///     "question_number": "24",
///     "issued_at": "2018-12-14 21:29:20",
///     "status": "D",
///     "appeal": "На наш взгляд, некорректным в вопросе является употребление слова \"бессмысленной\". Работа спасателей была бы бессмысленной, если бы, скажем, все погибли или если там просто не было бы людей, а в работе спасателей заключалась бы основная функция загаданного объекта. В описанных же в вопросе условиях работа спасателей была не бессмысленной, а в крайнем случае очень затруднённой (что написано, кстати, и в авторском источнике). Считаем эту ошибку в словоупотреблении существенной и просим снять вопрос.",
///     "comment": "Отклонить 3:0.\r\rЖюри полагает такое словоупотребление допустимой натяжкой (в бытовой ситуации мы часто говорим «бессмысленно» в значении «очень сложно, нецелесообразно»), которая не может помешать сдать авторский ответ.",
///     "resolved_at": "2018-12-19 18:41:06",
///     "answer": null
/// },
/// {
///     "type": "A",
///     "question_number": "25",
///     "issued_at": "2018-12-15 22:14:31",
///     "status": "A",
///     "appeal": "Как видно из статьи Википедии об этом журнале, он назывался по-разному, и слово \"Fiction\" присутствовало в названии далеко не всегда: https://ru.wikipedia.org/wiki/Astounding_Science_Fiction\r\n\r\nВ то же время, слово \"фантастический\" точно описывает состояние журнала в момент публикации истории.\r\n\r\nКроме того, мы играем на русском языке, указания давать ответ на английском языке или абсолютно точно не было, и поэтому даже если подставить наш и другие аналогичные ответы в \"предусмотренное\" автором место, нам конструкция \"Astounding Science фантастик/фантастический/фантастического\" представляется пусть не вполне грамотной, но полностью соответствующей реалиям вопроса \r\n\r\nПросим ответ засчитать.",
///     "comment": "Принять 2:1 (АВ, ИИ — за принятие; РХ — за отклонение).\r\rПри определённой подстановке ответа команды в текст вопроса можно получить корректное утверждение с точностью до неоптимального перевода: «…обыскала редакцию журнала «Удивительный научно-фантастический». И хотя в реальности более вероятна другая подстановка: «…обыскала редакцию фантастического журнала Astounding Science», большинством голосов жюри не считает такое отличие существенным в данном случае.\r\rТаким образом, подлежат зачёту спорные со следующими ID: 89642, 89455, 89616, 89669.",
///     "resolved_at": "2018-12-19 18:41:31",
///     "answer": "фантастического"
/// }
/// ]
import 'dart:convert';

import 'tournament_controversial.dart';

class TournamentAppeal {
  TournamentAppeal({
    this.type,
    this.questionNumber,
    this.issuedAt,
    this.status,
    this.appeal,
    this.comment,
    this.resolvedAt,
    this.answer,
  });

  final Type? type;
  final String? questionNumber;
  final DateTime? issuedAt;
  final QuestionStatus? status;
  final String? appeal;
  final String? comment;
  final DateTime? resolvedAt;
  final String? answer;

  factory TournamentAppeal.fromJson(String str) =>
      TournamentAppeal.fromMap(json.decode(str));

  String toJson() => json.encode(toMap());

  factory TournamentAppeal.fromMap(Map<String, dynamic> json) =>
      TournamentAppeal(
        type: json['type'] == null ? null : typeValues.map[json['type']],
        questionNumber:
            json['question_number'] == null ? null : json['question_number'],
        issuedAt: json['issued_at'] == null
            ? null
            : DateTime.parse(json['issued_at']),
        status:
            json['status'] == null ? null : statusValues.map[json['status']],
        appeal: json['appeal'] == null ? null : json['appeal'],
        comment: json['comment'] == null ? null : json['comment'],
        resolvedAt: json['resolved_at'] == null
            ? null
            : DateTime.parse(json['resolved_at']),
        answer: json['answer'] == null ? null : json['answer'],
      );

  Map<String, dynamic> toMap() => {
        'type': type == null ? null : typeValues.reverse[type],
        'question_number': questionNumber == null ? null : questionNumber,
        'issued_at': issuedAt == null ? null : issuedAt?.toIso8601String(),
        'status': status == null ? null : statusValues.reverse[status],
        'appeal': appeal == null ? null : appeal,
        'comment': comment == null ? null : comment,
        'resolved_at':
            resolvedAt == null ? null : resolvedAt?.toIso8601String(),
        'answer': answer == null ? null : answer,
      };
}

enum Type { A, R }

final EnumValues<Type> typeValues =
    EnumValues<Type>({'A': Type.A, 'R': Type.R});
